package hbs.ei.eiproxy;

import java.net.URI;
import java.net.URISyntaxException;

import io.undertow.Undertow;
import io.undertow.server.HttpHandler;
import io.undertow.server.HttpServerExchange;
import io.undertow.server.handlers.ResponseCodeHandler;
import io.undertow.server.handlers.proxy.LoadBalancingProxyClient;
import io.undertow.server.handlers.proxy.ProxyHandler;
import io.undertow.util.Headers;
import io.undertow.util.StatusCodes;

/**
 * @author Stuart Douglas
 */

public class Main {

    public static void main(final String[] args) {
        try {
            final Undertow server1 = Undertow.builder()
                    .addHttpListener(8082, "localhost")
                    .setHandler(new HttpHandler() {
                        
                        public void handleRequest(HttpServerExchange exchange) throws Exception {
                            //exchange.getResponseHeaders().put(Headers.CONTENT_TYPE, "text/plain");
                            //exchange.getResponseSender().send("Server1");
                            System.out.println("Server1");
                            exchange.getRequestHeaders().add(new io.undertow.util.HttpString("PERSON_ID"), "513999");
                            exchange.getResponseHeaders().add(new io.undertow.util.HttpString("PERSON_ID"), "513999");
                            exchange.getQueryParameters();
                            exchange.getRequestHeaders();
                            exchange.setRelativePath(exchange.getRequestURI());
                            exchange.setStatusCode(StatusCodes.OK);
                            exchange.setRelativePath(exchange.getRequestPath());
                            //exchange.getResponseSender().send("Server2");                            
                           // exchange.setRelativePath();
                            //exchange.endExchange();
                            
                        }
                    })
                    .build();

            server1.start();

            final Undertow server2 = Undertow.builder()
                    .addHttpListener(8083, "localhost")
                    .setHandler(new HttpHandler() {
                        @Override
                        public void handleRequest(HttpServerExchange exchange) throws Exception {
                            System.out.println("Server2");
                            exchange.getResponseHeaders().put(Headers.CONTENT_TYPE, "text/plain");                            
                            exchange.getRequestHeaders().add(new io.undertow.util.HttpString("PERSON_ID"), "513999");
                            exchange.getResponseHeaders().add(new io.undertow.util.HttpString("PERSON_ID"), "513999");
                            exchange.getQueryParameters();
                            exchange.getRequestHeaders();
                            exchange.setStatusCode(StatusCodes.OK);
                            exchange.setRelativePath(exchange.getRequestPath());
                           // exchange.setRelativePath();
                            //exchange.endExchange();
                        }
                    })
                    .build();
            server2.start();

            final Undertow server3 = Undertow.builder()
                    .addHttpListener(8084, "localhost")
                    .setHandler(new HttpHandler() {
                        
                        public void handleRequest(HttpServerExchange exchange) throws Exception {
                            exchange.getResponseHeaders().put(Headers.CONTENT_TYPE, "text/plain");
                            //exchange.getResponseSender().send("Server3");                            
                            System.out.println("Server3");
                            exchange.getRequestHeaders().add(new io.undertow.util.HttpString("PERSON_ID"), "513999");
                            exchange.getResponseHeaders().add(new io.undertow.util.HttpString("PERSON_ID"), "513999");
                            exchange.getQueryParameters();
                            exchange.getRequestHeaders();
                            exchange.setStatusCode(StatusCodes.OK);
                            exchange.setRelativePath(exchange.getRequestPath());
                            //exchange.getResponseSender().send("Server2");                            
                           // exchange.setRelativePath();
                            //exchange.endExchange();
                        }
                    })
                    .build();

            server3.start();

            LoadBalancingProxyClient loadBalancer = new LoadBalancingProxyClient()
                    .addHost(new URI("http://localhost:8081"))
                    .addHost(new URI("http://localhost:8082"))
                    .addHost(new URI("http://localhost:8083"))
                    .setConnectionsPerThread(20);

            Undertow reverseProxy = Undertow.builder()
                    .addHttpListener(8080, "localhost")
                    .setIoThreads(4)
                    .setHandler(new ProxyHandler(loadBalancer, 30000, ResponseCodeHandler.HANDLE_404))
                    .build();
            reverseProxy.start();
            
           
        } catch (URISyntaxException e) {
            throw new RuntimeException(e);
        }
    }

}
